//==============================================================================
// #_22.10.2020
//==============================================================================

extern "C" unsigned char getADC8(unsigned char nomeradc);

extern "C" 
{ void minit(void);
  void mslipping(void);
}
extern "C" unsigned char mknopki(void);

#include <Wire.h>
#include <Adafruit_BMP280.h>

#define BMP_SCK  (13)
#define BMP_MISO (12)
#define BMP_MOSI (11)
#define BMP_CS   (10)

//Adafruit_BMP280 bmp(BMP_CS);    // аппаратный SPI
Adafruit_BMP280 bmp(BMP_CS, BMP_MOSI, BMP_MISO,  BMP_SCK); // программный

// дисплей TFT
#include "UTFTGLUE.h"                 // подключение библиотеки
UTFTGLUE myGLCD(0x0154,A2,A1,A3,A4,A0); // подключение дисплея БУЛО !!!!
extern uint8_t SmallFont[]; // шрифт 

// эти функции в модулях tft.ino.  и knopki.ino 
// arduinoIDE НЕ требует их объявления
void initTFT(void);// инициализация дисплея и настройка картинки экрана
void grafik(void);

unsigned char mpress[48]; // массив значений давления
unsigned char chas = 7, mins = 1, sec = 33;  // часы,минуты, секунды,

// режим работы, 1 - питание от сети, 0 - работа от аккумулятора
unsigned char 
  oldregim  = 0,  // предыдущее значение
  regim     = 0;  // текущее значение

//==============================================================================
void setup()
{
  minit();
  
 if (!bmp.begin())  // если датчик не включился
 {  digitalWrite(8,HIGH); // постоянно горит синий светодиод
    while (1) { }
 }

  /* Default settings from datasheet. это взято из примера в библиотеке */
  bmp.setSampling(Adafruit_BMP280::MODE_NORMAL,     /* Operating Mode. */
                  Adafruit_BMP280::SAMPLING_X2,     /* Temp. oversampling */
                  Adafruit_BMP280::SAMPLING_X16,    /* Pressure oversampling */
                  Adafruit_BMP280::FILTER_X16,      /* Filtering. */
                  Adafruit_BMP280::STANDBY_MS_500); /* Standby time. */

// заполняем массив данных начальными данными
  unsigned char i = 0;
  for (i = 0; i < 48; i++)
  { mpress[i] = i;
  }
  mpress[47] = (bmp.readPressure()/133.322) - 720 ;
}
//===============================================================================
// работа с датчиком
void datchik(void)
{ unsigned char i = 0;
  
  if ((mins ==  2)&&(sec == 10))       // время измерения
  { 
// сдвигаем данные в массиве
    for (i = 1; i < 48; i++)
    { mpress[i-1] = mpress[i];
    }
    mpress[47] = (unsigned char)((bmp.readPressure()/133.322) - 720);
    delay(1000);      // задержка против повторения
  
    if (regim == 1)   // 1 - питание наличествует
    { 
      grafik();
    }      
  }
}
//==============================================================================
void showtime(void)
{
  myGLCD.setTextSize(4); // перенесен сюда
  myGLCD.setCursor(24,346);
  String str = "";
  if (chas < 10)  str = "0" + String(chas) + ":";
  else            str = String(chas) + ":";
  if (mins < 10)  str = str + "0" + String(mins) + ":";
  else            str = str + String(mins) + ":";
  if (sec < 10)   str = str + "0" + String(sec);
  else            str = str + String(sec);

// калибровка порога напряжения питания
//  str =  "1234U" + String(getADC8(14));// 
//  myGLCD.setCursor(1,345);

  myGLCD.println(str);
}
//===============================================================================
void loop(void)
{
  datchik();    // работа с датчиком

// проверим наличие питания
  if (getADC8(14) < 58) // питание есть
  {
    regim = 1;
    if (oldregim == 0)// если питание от сети только что включилось
    { initTFT();
      grafik();
//      showtime();
    } 
    showtime();
    delay(50);       // чтоб не так быстро
    if (mknopki() == 1) // если была нажата кнопка
    { showtime();
      delay(200);       // чтоб не так быстро
    }
  }
  else                  // питание отсутствует
  { regim = 0;
    mslipping();        // "спящий" режим
  }
  
  oldregim = regim;
}
//===============================================================================

