//==============================================================================
// функции для работы с дисплеем TFT
//==============================================================================
// инициализация дисплея и настройка картинки экрана
void initTFT(void)
{ myGLCD.InitLCD(); // инициализация дисплея

  myGLCD.setRotation(0);  // шина данных справа, шина управления слева
  myGLCD.setFont(SmallFont);
  myGLCD.clrScr();

  myGLCD.setColor(0, 0,32); 
  myGLCD.fillRect(0, 20, 199, 330); // заполнение экрана
  
  myGLCD.setColor(255,255,255); // белая рамка рабочей области   
  myGLCD.drawRect(0, 20, 201, 331);
  myGLCD.drawRect(1, 19, 200, 332);
  
  myGLCD.setColor(0,255,0);  
  myGLCD.print("* B A R O G R A F v.28.12.2020 *", CENTER, 5);

  myGLCD.setTextSize(1);  
  myGLCD.setTextColor(0b0111101111101111, 0); // серый цвет
  
  unsigned char i;
  for (i = 1; i < 7; i++)                   // шкала справа
  { myGLCD.setCursor(218, 20 + (7-i)*50);
    myGLCD.println("7" + String(i+1)+"0");
  }
}

void grafik(void)
{ unsigned char i = 0, oX;
  unsigned int tmp = 0;
  myGLCD.setColor(0, 0,32); 
  myGLCD.fillRect(2, 20, 199, 330); // заполнение экрана
  unsigned int j;
  myGLCD.setColor(0,128,0);  // зеленые  

  for (j = 30; j < 351; j += 50)  // горизонтальная сетка
  { 
    myGLCD.drawLine(2, j, 230, j);
  }
  myGLCD.drawLine(100, 20, 100, 330);  // вертикальная линия-раздел суток
  myGLCD.setColor(255,255,255);  

  unsigned int tmp1,tmp2;

  myGLCD.setColor(255,255,0);  
  for (i = 1; i < 48; i++)
  { oX = 10 + 4*i;
    tmp1 = 5*mpress[i-1];      
    tmp2 = 5*mpress[i];
          
    myGLCD.drawLine(oX-3, 330-tmp1, oX+1, 330-tmp2);
    myGLCD.drawLine(oX-4, 330-tmp1, oX, 330-tmp2);
  }
  
  myGLCD.setColor(0,0,0);   // очистка для столбика
  myGLCD.fillRect(204, 330, 214, 50);
  myGLCD.setColor(255,0,0);  // красный столбик-текущее давление
  myGLCD.fillRect(206, 330, 214, 330-tmp2);

// вывод в разные части экрана текущих значений давления и температуры
  myGLCD.setTextColor(0xFFE0, 0); //YELLOW
  myGLCD.setTextSize(4); 
  myGLCD.setCursor(14, 45);
  myGLCD.println("7" + String(mpress[47] + 20));// + "mmHg");

  myGLCD.setTextColor(0x0F1F, 0); // CYAN
  myGLCD.setTextSize(2); 
  myGLCD.setCursor(59, 383);
  unsigned char t = bmp.readTemperature();
  myGLCD.println("T= +" + String(t)+" grC");
//*********************************************************************
 
}

